<!DOCTYPE html>
<html>
<head>
<?php
/*
	Picstory v1.2
	Thomas Pimmel 2018
*/
session_name('index'); 
session_start();
$_SESSION['project']="";	// éviter reconnexion

require ("include/cfg.php");
if (!file_exists("projects"))	mkdir("projects");
/* si fichier de config n'existe pas, appeler init.php */
if (!file_exists("projects/users.php"))
{
	if (!isset($_POST['langue'])||!$_POST['langue'])
	{
		header("Location:init.php");      
		exit();
	}
	else
	{
		$conf="<?php\n".'$ADMlng="'.$_POST['langue'].'"'.";\n".'$ADMFlags=188;'."\n".'$ADMMdp="";'."\n?>";
		file_put_contents("projects/users.php",$conf);
	}
}
require ("projects/users.php");
require ("lng/lng.php");
/* si dossiers archive / log / tasks / n'existent pas, les créer */
if (!file_exists("archives"))	mkdir("archives");
if (!file_exists("log"))	mkdir("log");
if (!file_exists("tasks"))	mkdir("tasks");
if (!file_exists("fonts"))	mkdir("fonts");

CreateLang($ADMlng);
jslanguages();
/* No splash */
if (isset($_GET['opt']) && $_GET['opt']=='nosplash')	$_SESSION['splash']=false;
else													$_SESSION['splash']=true;
?>
<title>Picstory 1.2</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link rel="icon" type="image/png" href="data/psicona.png" />
<link href="data/idx.css" rel="stylesheet" type="text/css">
<link href="data/project.css" rel="stylesheet" type="text/css">
<?php
loadjs("js/jquery-3.3.1");
loadjs("js/jquery.md5");
loadjs("lng/lng");
loadjs("js/index");
loadjs("js/adm");
loadjs("js/filter");
loadjs("js/infobulle");
?>
</head>
<body onclick='idx_leftmouse(event);'>
<div id="maindiv">
<?php
/****** détection ipad.. **********/
//if (detectmobile())	$_SESSION['PSSquare']=100;
//else				$_SESSION['PSSquare']=90;
$_SESSION['PSSquare']=120;
if (!file_exists("fonts/fonts.txt"))	refreshFonts();
/* Flags admin */
print("<script>var ADMFlags=".$ADMFlags.";\nvar PSVersion=".PS_VERSION.";</script>");
/**** Entête et déco **********/
if ($_SESSION['splash'])
{
	print('<div id="centerlogo">');
	print('<div style="position:absolute;bottom:0px;">Picstory (c) Thomas Pimmel 2017-2018</div>');
	print("</div>");
}
/* fenêtre popup */
print("<div id='popup'></div>");
/* Barre de titre */
print("<div class='titleleft' onmouseover='_IB(this,\""._translate("Configuration")."\");' onclick='idx_configuration(event)'><img src='data/square/config.svg'></div>");
print("<div class='titleleft' onmouseover='_IB(this,\""._translate("À propos de Picstory")."\");' onclick='idx_about(event)'><img src='data/square/about.svg'></div>");
print("<div onmouseover='_IB(this,\""._translate("Temps de réaction du serveur")."\");' id='titleright'>0 ms</div>");

/* titre */
print("<p id='maintitle'><span>P</span><span style='font-style:italic;color:rgba(20,90,255,.8);font-size:1.2em;");
print("margin-right:-.1em;margin-left:-.2em'>i</span><span>cStory</span><span style='font-size:.3em'>(".PS_VERSION.")</span></p>");
// Affichage des projets
PSGetProjects();
?>
</div>
</body>
</html>
<?php
/* SP Index */
function PSGetProjects()
{
	print (PSdrawChoice(_translate("Choisissez un projet")));
	$liste=PSlistProjects();
	PSdrawSquareSimple("plus.svg",_translate("Nouveau"),"idx_newproject",_translate("Créer un nouveau projet"));
	$idx=1;
	foreach ($liste as $entry)
	{
		if ($entry[1])	$svg="projectlock.svg";
		else			$svg="project.svg";
		PSdrawSquare($svg,$entry[2],$idx++,_translate("Modifier le projet"));
	}
	print("</div>");
	print("<script>var nbsquares=".$idx.";</script>");
	/* menu context */
	print("<div id='ctxmenu'></div>");
}
/* ----Util------ */
/* dessin d'un carré */
function PSdrawSquareSimple($image,$text,$link,$help)
{
	if ($help)	$help="onmouseover='_IB(this,\"$help\");'";
	print("<div id='ps_square0' $help ontouchstart='idx_touchstart(event,0)' ontouchend='idx_touchend(event,0)' oncontextmenu='idx_menu(event,0)' class='squarediv' onclick='".$link."(event);'><img src='data/square/".$image."' width='".$_SESSION['PSSquare']."px'>");
	print("<br>".$text."</div>");

}
function PSdrawSquare($image,$text,$id,$help="")
{
	if ($help)	$help="onmouseover='_IB(this,\"$help\");'";
	$link="onclick='idx_openproject(event,$id);'";
	print("<div $help ontouchstart='idx_touchstart(event,$id)' ontouchend='idx_touchend(event,$id)' oncontextmenu='idx_menu(event,$id)' class='squarediv' id='ps_square$id' $link><img src='data/square/".$image."' width='".$_SESSION['PSSquare']."px'>");
	print("<br>".$text."</div>");
}

/* dessin d'un cadre */
function PSdrawChoice($title)
{
	$splash="";
	if (!$_SESSION['splash'])	$splash=" style='animation:none;'";	
	return "<div id='choicediv'$splash><span id='choicespan'>$title</span>";
}
/* liste des projets */
function PSlistProjects()
{
	if (!file_exists("projects"))
	{
		mkdir("projects");
		return	false;
	}
	$idx=0;
	$dir=scandir("projects");
	$liste=array();
	print("\n<script>var projlist=[");
	foreach($dir as $entry)
	{
		if ($entry!='.' && $entry!='..' && is_dir("projects/".$entry))
		{
			if (file_exists("projects/".$entry."/mdp.txt"))		$key=true;
			else												$key=false;
			if (file_exists("projects/".$entry."/name.txt"))	$name=file_get_contents("projects/".$entry."/name.txt");
			else												$name=$entry;
			$liste[]=array($entry,$key,$name);
			if ($idx++)	print(",");
			print('"'.$name.'"');
		}
	}
	print("];</script>\n");
	$_SESSION['projlist']=$liste;
	return $liste;
}
/* Détection mobile */
function detectmobile(){
    $agent = $_SERVER['HTTP_USER_AGENT'];
    $useragents = array (
        "iPhone",
        "iPod",
        "iPad",
        "Android",
        );
        $result = false;
    foreach ( $useragents as $useragent ) {
    if (preg_match("/".$useragent."/i",$agent)){
            $result = true;
        }
    }
return $result;
}
/* mise à jour et traitement des polices */
function refreshFonts()
{
	require_once("include/ttfinfo.php");
	// fabriquer allfont
	$allfont="";
	$files=glob("fonts/*.ttf");
	for ($i=0;$i<count($files);$i++)
	{
		// convertir en .woff
		//sfnt2woff
		$woffname=str_ireplace(".ttf",".woff",$files[$i]);
		if (!file_exists($woffname)&&file_exists(PS_PATH."sfnt2woff"))	exec(PS_PATH."sfnt2woff ".str_replace(" ","\ ",$files[$i]));
		// compléter allfont
		$name=getFontInfo($files[$i]);
		$name[1]=strtolower($name[1]);
		$allfont.=str_replace(" ","_",$name[1]);
		$allfont.="|".str_replace("fonts/","",$files[$i]);
		if (file_exists($woffname))	$allfont.="|".str_replace("fonts/","",$woffname);
		if (isset($files[$i+1]))	$allfont.="\n";
	}
	file_put_contents("fonts/fonts.txt",$allfont);
	// fabriquer le css et le javascript
	fontScript($allfont);
}
function fontScript($liste)
{
	$css="/*Do not edit */\n";
	$js="/*Do not edit */\nvar FontFamily=[";
	$fontlist=explode("\n",$liste);
	for ($i=0;$i<count($fontlist);$i++)
	{
		$onefont=explode("|",$fontlist[$i]);
		$onefont[0]=str_replace(["'","!"],"",$onefont[0]);
		$css.="@font-face {\nfont-family: \"".$onefont[0]."\";\n";
		if (isset($onefont[2]))	$css.="src: url(\"".$onefont[2]."\") format('woff');\n";
		$css.="src: url(\"".$onefont[1]."\") format('truetype');\n}\n";
		$js.="\"".$onefont[0]."\"";
		if (isset($fontlist[$i+1]))	$js.=",";
		else						$js.="];\n";
	}
	file_put_contents("fonts/fonts.css",$css);
	file_put_contents("fonts/fonts.js",$js);
}
/* chargement des javascript */
function loadjs($js)
{
	if (file_exists("$js.min.js"))	print("<script src='$js.min.js'></script>\n");
	else							print("<script src='$js.js'></script>\n");
}
/* langages disponibles */
function jslanguages()
{
	$lang=scandir("lng");
	print("<script>var ADMlngtab=[");
	for ($i=0;$i<count($lang);$i++)
	{
		if ($lang[$i]!="." && $lang[$i]!=".." && is_dir("lng/".$lang[$i]))
		{
			print('"'.$lang[$i].'",');
		}
	}
	print("];</script>\n");
}
?>