<?php
/*
	Picstory v1
	Thomas Pimmel 2017
*/
require ("include/cfg.php");
?>
  <!DOCTYPE html>
<html>
<head>
<title>Picstory : vérification de la configuration</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
</head>
<body>
<div>
<?php
	Main();
function Main()
{
	/* couper commande ffmpeg */
	$ffm=explode(" ",PS_FFCMD);
	$ffcmd=$ffm[0];

	/* tests */
	$nberrors=0;
	print("<h1>PICSTORY ".PS_VERSION." Vérification de la configuration de votre système</h1>");
	print("Rien ne sera modifié sur votre système, informations uniquement<br>");
	print("Le système hébergeant Picstory est détecté comme \"".PHP_OS."\"<br>");
	if (PHP_OS=="Darwin")
	{
		print("Vous avez installé Picstory sur Mac OS. Vous allez devoir modifier le fichier de configuration, car
		je ne peux pas réaliser de tests sur ce système. Merci de bien vouloir prendre contact avec moi, je suis intéressé par les résultats.<br>");
	}
	$where="";
	if (!PS_WINDOWS)
	{
		exec("whereis -h",$output,$statut);
		if ($statut)
		{
			$where="/usr/bin/";
			exec($where."whereis -h",$output,$statut);
			if ($statut)	$where=PS_PATH;
		}
		print("<br>");
		print(findexec("php",$where));
		print(findexec("convert",$where));
		print(findexec("ffmpeg",$where));
		print(findexec("nice",$where));
		print("Modifiez éventuellement la configuration<br><br>");
	}

	print("Version de PHP ".PHP_VERSION."<br>");
	if (version_compare(PHP_VERSION, '5.3') < 0)
	{
		$nberrors++;
		print("<span style='color:red'>Une version 5.3 de PHP minimum est requise.</span><br>");
	}
	print("<br>Chemin des commandes : ".PS_PATH."<br><br>");
	print("Taille maximum d'une image téléchargée : ".ini_get('upload_max_filesize')."<br>");
	print("Images en une fois : ".ini_get('post_max_size')."<br>");
	print("Temps maximal d'exécution d'un programme : ".ini_get('max_execution_time')." secondes<br>");
	//ps_exec(PS_CONVCMD,"-list resource","Test");
	$nberrors+=ps_exec(PS_CONVCMD,"-version","Installez le programme imagemagick");
	$nberrors+=ps_exec($ffcmd,"-version","Installez le programme ffmpeg");
	ps_findcodec($ffcmd." -codecs");
	if (!PS_WINDOWS)	$nberrors+=ps_exec(PS_PHP,"--version","chemin vers l'exécutable php incorrect.");
	if ($nberrors)
	{
		print("<p style='color:red'>il y a eu $nberrors erreur(s). Modifiez votre cfg.php ou votre installation en conséquence.</p>");
	}
	else		print("<p style='color:blue'>Aucune erreur.</p>");
}
function ps_exec($command,$args="",$msg)
{
	if ($args)	$exec=$command." ".$args;
	else			$exec=$command;
	exec($exec,$output,$status);
	print("<p>$exec<br>");
	if ($status)
	{
		print("<span style='color:orange'>$command a retourné une erreur<br>$msg</span><br>");
	}
	foreach ($output as $line)	print("$line<br>");
	print("</p>");
	if ($status)	return 1;
	else			return 0;
}
function ps_findcodec($exec)
{
	print("Recherche des codecs...<br>");
	$find=false;
	exec($exec,$output,$status);
	if (!$status)
	{
		foreach($output as $line)
		{
			if (stripos($line,"libx264"))
			{
				print($line."<br><span style='color:blue'>OK!</span><br>");
				$find=true;
			}
		}
	}
	if (!$find)	print("<span style='color:green'>Attention : ffmpeg ne semble pas configuré pour codifier des mp4. Vérifiez la présence de 'libx264' sur votre système </span><br>");
}

function findexec($exec,$path)
{
		exec($path."whereis -b ".$exec,$output,$statut);
		if (!$statut)
		{
			print("Recherche de : ");
			foreach ($output as $line)	print("$line<br>");
		}
}
?>
</div>
</body>